/*
 *  Copyright 2019-2020  Jie
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package com.youchain.basicdata.service;

import com.youchain.RequestData.TransTask;
import com.youchain.appupdate.ReturnJson.ReturnTaskVo;
import com.youchain.basicdata.domain.Stock;
import com.youchain.basicdata.service.dto.StockDto;
import com.youchain.basicdata.service.dto.StockQueryCriteria;
import com.youchain.businessdata.domain.Pick;
import org.springframework.data.domain.Pageable;

import java.util.Map;
import java.util.List;
import java.io.IOException;
import java.util.Set;
import javax.servlet.http.HttpServletResponse;

/**
 * @author liuxue
 * @website https://elAdmin.vip
 * @description 服务接口
 * @date 2023-07-28
 **/
public interface StockService {

    /**
     * 查询数据分页
     *
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(StockQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     *
     * @param criteria 条件参数
     * @return List<StockDto>
     */
    List<StockDto> queryAll(StockQueryCriteria criteria);


    /**
     * 根据ID查询
     *
     * @param id ID
     * @return StockDto
     */
    StockDto findById(Long id);

    /**
     * 创建
     *
     * @param resources /
     * @return StockDto
     */
    StockDto create(Stock resources);

    /**
     * 编辑
     *
     * @param resources /
     */
    void update(Stock resources);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(Long[] ids);

    /**
     * 导出数据
     *
     * @param all      待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<StockDto> all, HttpServletResponse response) throws IOException;

    /**
     * dto转实体
     *
     */
    Stock toEntity(StockDto stockDto);

    /**
     * 查询所有数据不分页
     *
     * @param code 编号
     */
    List<Stock> findByKyStockList(String code);

    /**
     *
     * @param code 容器
     * @param status 状态
     */
    Stock findByCode(String code, String status);

    String getItemCode(String stockCode);

    /**
     * 容器入场JSON
     *
     * @param containerCode 容器
     * @param position 点位
     */
    String containerInJson(String containerCode, String position);

    /**
     * 容器出场JSON
     *
     * @param containerCode 容器
     */
    String containerOutJson(String containerCode);

    /**
     * 容器入场
     *
     * @param containerCode 容器
     * @param position 点位
     */
    void containerIn(String containerCode, String position);

    /**
     * 容器出场
     *
     * @param containerCode 容器
     */
    void containerOut(String containerCode);

    /**
     * 任务放行
     *
     * @param code 编号
     */
    void operationFeedback(String code);


    /**
     * 批量查询箱号
     * @param stockCodes 箱号集合
     */
    Map<String, Stock> findByCodes(Set<String> stockCodes);

    /**
     * 原材料入库
     *
     * @param stockCode 托盘
     * @param boxNumbers 箱号
     * @param pointCode 点位
     */
    void materialIn(String stockCode, List<String> boxNumbers, String pointCode);

    /**
     * 扫描托盘
     *
     * @param stockCode 托盘
     */
    ReturnTaskVo scanStock(String stockCode);

    /**
     * 翻包拣货
     *
     * @param taskId 任务ID
     * @param orderNumber 箱号
     * @param dstStockCode 目标托盘
     */
    void fbPicking(Long taskId, String orderNumber, String dstStockCode);

    /**
     * 搬运任务
     *
     * @param transTask 搬运任务
     */
    void moveStock(TransTask transTask);

    /**
     * 解绑容器
     * @param stockCode 容器
     */
    void unBindContainer(String stockCode);

    /**
     * 下发叫料任务
     * @param pick 出库单
     */
    void  callJlTask(Pick pick);

    /**
     * 消息推送
     */
    String stockMsg();

}
